﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using HarmonyLib;
using JetBrains.Annotations;
using UnityEngine;
using FMODUnity;
using Random = UnityEngine.Random;
using UnityEngine.AI;
using System.Threading.Tasks;


[HarmonyPatch(typeof(Seagull), "Start")]
public class Patch_StartSeagullProcess
{
    private static string gmode = "Easy";
    static System.Random rand = new System.Random();
    private static void Prefix(ref Seagull __instance)
    {
        if (Semih_Network.IsHost)
        {
            gmode = GameModeValueManager.GetCurrentGameModeValue().gameMode.ToString();
            float searchCrop = rand.Next(60,420);
            float fSpeed = rand.Next(50,90);
            float sRadius = rand.Next(30,100);
            float eatCrop = rand.Next(7,13);
		    if (gmode == "Hardcore") 
            { 
                searchCrop = rand.Next(50,360);
                fSpeed = rand.Next(60,100);
                sRadius = rand.Next(40,80);
                eatCrop = rand.Next(6,11);
            }
		    if (gmode == "Easy") 
            { 
                searchCrop = rand.Next(100,480);
                fSpeed = rand.Next(40,80);
                sRadius = rand.Next(25,120);
                eatCrop = rand.Next(8,15);
            }
            Traverse.Create(__instance).Field("searchCropInterval").SetValue(searchCrop/60f);
            Traverse.Create(__instance).Field("removeDeadTime").SetValue(60f); 
            Traverse.Create(__instance).Field("flightSpeed").SetValue(fSpeed/10f);
            Traverse.Create(__instance).Field("searchPlayerRadius").SetValue(sRadius/10f);
            Traverse.Create(__instance).Field("timeUntilEatCrop").SetValue(eatCrop); 
        }
    }
}

[HarmonyPatch(typeof(Seagull), "Peck")]
public class Patch_PeckSeagullProcessVSScarecrow
{
    static System.Random rand = new System.Random();
    private static bool Prefix(ref Seagull __instance)
    {
        if (Semih_Network.IsHost)
        {
            if (__instance.targetScarecrow != null)
            {
                int durability = rand.Next(1,4);
                if (durability != 1)
                {
                    __instance.SwitchState(SeagullState.Hover);
                    return false;
                }
            }
            return true;
        }
        return false;
    }
}

[HarmonyPatch(typeof(Seagull), "Update")]
public class Patch_Seagullypositioncheck
{
    static System.Random rand = new System.Random();
    private static void Prefix(ref Seagull __instance)
    {
        if (Semih_Network.IsHost)
        {
            if (__instance.transform.position.y > 500)
            {
                Traverse.Create(__instance).Field("flightSpeed").SetValue(600);
            }
            if (__instance.transform.position.x - RAPI.GetLocalPlayer().transform.position.x > 350 || __instance.transform.position.x - RAPI.GetLocalPlayer().transform.position.x < -350)
            {
                Traverse.Create(__instance).Field("flightSpeed").SetValue(600);
            }
            if (__instance.transform.position.z - RAPI.GetLocalPlayer().transform.position.z > 350 || __instance.transform.position.z - RAPI.GetLocalPlayer().transform.position.z < -350)
            {
                Traverse.Create(__instance).Field("flightSpeed").SetValue(600);
            }
            if (Traverse.Create(__instance).Field("flightSpeed").GetValue<float>() > 11 && __instance.transform.position.y < 200 && __instance.transform.position.z - RAPI.GetLocalPlayer().transform.position.z < 350 && __instance.transform.position.z - RAPI.GetLocalPlayer().transform.position.z > -350 && __instance.transform.position.x - RAPI.GetLocalPlayer().transform.position.x < 350 && __instance.transform.position.x - RAPI.GetLocalPlayer().transform.position.x > -350)
            {
                float fSpeed = rand.Next(50,100);
                Traverse.Create(__instance).Field("flightSpeed").SetValue(fSpeed/10f);
            }
		}
    }
}

[HarmonyPatch(typeof(SeagullParent), "Update")]
public class Patch_Seagullypositioncheckmaxheight
{
    private static void Prefix(ref SeagullParent __instance)
    {
        if (Semih_Network.IsHost)
        {
            if (__instance.HoverCenterPoint.y < 18 || __instance.HoverCenterPoint.y > 24)
            {
                float tempHover = Traverse.Create(__instance).Field("hoverHeightCenter").GetValue<float>();
                if (__instance.HoverCenterPoint.y > 5000)
                {
                    tempHover -= 4000;
                }
                if (__instance.HoverCenterPoint.y > 500)
                {
                    tempHover -= 400;                
                }
                if (__instance.HoverCenterPoint.y > 24)
                {
                    tempHover -= 20;                
                }
                if (__instance.HoverCenterPoint.y < -1000)
                {
                    tempHover += 1000;                
                }
                if (__instance.HoverCenterPoint.y < -300)
                {
                    tempHover += 300;                
                }
                if (__instance.HoverCenterPoint.y < 0)
                {
                    tempHover += 20;                
                }
                if (__instance.HoverCenterPoint.y < 18)
                {
                    tempHover += 3;                
                }
                Traverse.Create(__instance).Field("hoverHeightCenter").SetValue(tempHover);
            }
        }
    }
}

[HarmonyPatch(typeof(Network_Host_Entities), "Start")]
public class Patch_StartSeagullMaxSet
{
    private static string gmode = "Easy";
    
    private static void Prefix(ref Network_Host_Entities __instance)
    {
        gmode = GameModeValueManager.GetCurrentGameModeValue().gameMode.ToString();
		if (gmode == "Hardcore") 
        { 
            Traverse.Create(__instance).Field("seagullMaxCount").SetValue(20); 
        }
		if (gmode == "Normal") 
        { 
            Traverse.Create(__instance).Field("seagullMaxCount").SetValue(8); 
        }
        if (gmode == "Easy") 
        { 
            Traverse.Create(__instance).Field("seagullMaxCount").SetValue(4); 
        }
    }
}

[HarmonyPatch(typeof(Seagull), "FindCropplotAndNest")]
public class Patch_CropplotSeagullProcess
{
    static System.Random rand = new System.Random();  
    private static string gmode = "Easy";

    private static void Prefix(ref Seagull __instance) 
    {   
        if (Semih_Network.IsHost)
        {   
            gmode = GameModeValueManager.GetCurrentGameModeValue().gameMode.ToString();
            float searchCrop = rand.Next(60,420);
            float fSpeed = rand.Next(50,90);
            float sRadius = rand.Next(30,100);
            float eatCrop = rand.Next(7,13);
		    if (gmode == "Hardcore") 
            { 
                searchCrop = rand.Next(50,360);
                fSpeed = rand.Next(60,100);
                sRadius = rand.Next(40,80);
                eatCrop = rand.Next(6,11);
            }
		    if (gmode == "Easy") 
            { 
                searchCrop = rand.Next(100,480);
                fSpeed = rand.Next(40,80);
                sRadius = rand.Next(25,120);
                eatCrop = rand.Next(8,15);
            }
            Traverse.Create(__instance).Field("searchCropInterval").SetValue(searchCrop/60f);
            Traverse.Create(__instance).Field("removeDeadTime").SetValue(60f); 
            Traverse.Create(__instance).Field("flightSpeed").SetValue(fSpeed/10f);
            Traverse.Create(__instance).Field("searchPlayerRadius").SetValue(sRadius/10f);
            Traverse.Create(__instance).Field("timeUntilEatCrop").SetValue(eatCrop); 
            int nCrop = PlantManager.allCropplots.Count;
            int nNest = BirdsNest.AllNests.Count;
            Cropplot crplt;
            BirdsNest brdns;
            while (nCrop > 1) 
            {  
                nCrop--;  
                int kCrop = rand.Next(nCrop + 1);  
                crplt = PlantManager.allCropplots[kCrop];  
                PlantManager.allCropplots[kCrop] = PlantManager.allCropplots[nCrop];  
                PlantManager.allCropplots[nCrop] = crplt;  
            } 

            while (nNest > 1) 
            {  
                nNest--;  
                int kNest = rand.Next(nNest + 1);  
                brdns = BirdsNest.AllNests[kNest];  
                BirdsNest.AllNests[kNest] = BirdsNest.AllNests[nNest];  
                BirdsNest.AllNests[nNest] = brdns;  
            }
        }
    }

    private static void Postfix(ref Seagull __instance)
    {
        if (Semih_Network.IsHost)
        {
            int nNest = BirdsNest.AllNests.Count;
            if (nNest >= 1)
            {
                gmode = GameModeValueManager.GetCurrentGameModeValue().gameMode.ToString();
                if (gmode == "Hardcore") 
                { 
                    nNest = 2*nNest - 2;
                }
		        if (gmode == "Normal") 
                { 
                    nNest = 5*nNest - 5;
                }
                if (gmode == "Easy") 
                { 
                    nNest = 10*nNest -10;
                }
                if (nNest > 40)
                {
                    nNest = 40;
                }
                int CropOrNest = rand.Next(1,nNest+40);
                if (CropOrNest >= 28)
                {
                    __instance.targetCropplot = null;
                    __instance.targetScarecrow = null;
                    __instance.targetPoint = null;
                }
                if (__instance.targetPoint == null)
                {
                    foreach (BirdsNest birdsNest in BirdsNest.AllNests)
	                {
		                if (!birdsNest.Occuppied)
		                {
		        	        Transform birdlandingPos = __instance.GetBirdlandingPos(birdsNest.transform);
		          	        Vector3 point = (birdlandingPos != null) ? birdlandingPos.position : birdsNest.transform.position;
                        
                            if (Traverse.Create(__instance).Method("CheckVisionToPoint", point, "BirdsNest", QueryTriggerInteraction.Collide).GetValue<bool>() && !Traverse.Create(__instance).Method("PlayerIsWithinVicinity", point, Traverse.Create(__instance).Field("searchPlayerRadius").GetValue()).GetValue<bool>())
		          	        {
                                Scarecrow scarecrowInVicinity2 = Traverse.Create(__instance).Method("GetScarecrowInVicinity", point, Traverse.Create(__instance).Field("searchScarecrowRadius").GetValue(), false).GetValue<Scarecrow>();
		           		        __instance.SwitchState(SeagullState.Hover); //turns off the booleans for anim that were set by State dive towards cropplot
                                if (scarecrowInVicinity2 == null)
			                    {
			            	        __instance.currentNest = birdsNest;
			            	        __instance.currentNest.Occuppied = true;
			            	        __instance.targetPoint = __instance.GetBirdlandingPos(__instance.currentNest.transform);
			            	        __instance.SwitchState(SeagullState.Dive);
			            	        break;
			                    }
			                    __instance.targetScarecrow = scarecrowInVicinity2;
			                    __instance.targetScarecrow.Occupied = true;
			                    __instance.targetPoint = __instance.GetBirdlandingPos(__instance.targetScarecrow.transform);
			                    __instance.SwitchState(SeagullState.Dive);
			                    break;
                            }
                        }
			        }
		        }
            }
        }
    }
}

public class RandomAnimalSpawns : Mod
{
    public static RandomAnimalSpawns instance;
    private Harmony harmonyInstance;
    private float timerSpawnAnimal;   

    public void Start()
    {
        instance = this;
        harmonyInstance = new Harmony("com.nephlymio.randomanimalspawns");
        harmonyInstance.PatchAll();
        Debug.Log("RandomAnimalSpawns Loaded! ... Gotta Catch them all!");
    }

    public void Update()
    {
        if (Semih_Network.IsHost)
        {
            if (!AnimalSpawnLandmark_Patch.shouldSpawnThisPatch)
            {
                timerSpawnAnimal += Time.deltaTime;
                if (timerSpawnAnimal >= 10f)
                {
                    timerSpawnAnimal = 0f;
                    AnimalSpawnLandmark_Patch.shouldSpawnThisPatch = true;
                }
            } 
        }
    }

    public async static void AddSeagull(Vector3 position)
	{
		await Task.Delay(1000);
        GameModeValueManager.GetCurrentGameModeValue().seagullVariables.shouldSpawn = true;
        ComponentManager<Network_Host_Entities>.Value.CreateSeagull(position, SaveAndLoad.GetUniqueObjectIndex(), SaveAndLoad.GetUniqueObjectIndex(), NetworkUpdateManager.GetUniqueBehaviourIndex());
    }

    public void OnModUnload()
    {
        harmonyInstance.UnpatchAll("com.nephlymio.randomanimalspawns");
        Debug.Log("Mod RandomAnimalSpawns has been unloaded!");
    }
    
    [HarmonyPatch(typeof(LandmarkEntitySpawner)), HarmonyPatch("CreateEntity")]
    [UsedImplicitly]
    public class AnimalSpawnLandmark_Patch
    {
        static System.Random rand = new System.Random();
        private static bool m_isInPatchMode;
        private static readonly Queue<uint> m_disposableAnimals = new Queue<uint>();
        private static readonly List<string> m_usableWaterItemNames = new List<string>()
            {
                "Stone",
                "Clay",
                "Sand"
            };
        
        private static readonly List<string> m_usableItemNames = new List<string>()
            {
                "Flower",
                "Pineapple",
                "Watermelon",
                "Berries",
                "Mushroom"
            };

        private static readonly AI_NetworkBehaviourType[] m_domesticTypes = 
            {
            AI_NetworkBehaviourType.Llama,
            AI_NetworkBehaviourType.Chicken,
            AI_NetworkBehaviourType.Goat,
            AI_NetworkBehaviourType.Pig,
            AI_NetworkBehaviourType.Boar,
            AI_NetworkBehaviourType.Bear,
            AI_NetworkBehaviourType.StoneBird,
            AI_NetworkBehaviourType.StoneBird_Caravan,
            AI_NetworkBehaviourType.BugSwarm_Bee,
            AI_NetworkBehaviourType.PufferFish
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_A = 
            {
            AI_NetworkBehaviourType.Llama,
            AI_NetworkBehaviourType.Boar
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_B = 
            {
            AI_NetworkBehaviourType.Goat,
            AI_NetworkBehaviourType.Bear
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_C = 
            {
            AI_NetworkBehaviourType.Chicken,
            AI_NetworkBehaviourType.Pig
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_D = 
            {
            AI_NetworkBehaviourType.Chicken,
            AI_NetworkBehaviourType.Goat,
            AI_NetworkBehaviourType.Llama,
            AI_NetworkBehaviourType.StoneBird_Caravan
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_E = 
            {
            AI_NetworkBehaviourType.StoneBird_Caravan,
            AI_NetworkBehaviourType.StoneBird,
            AI_NetworkBehaviourType.BugSwarm_Bee,
            AI_NetworkBehaviourType.Chicken
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_F = 
            {
            AI_NetworkBehaviourType.Boar,
            AI_NetworkBehaviourType.Pig,
            AI_NetworkBehaviourType.Bear
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_G = 
            {
            AI_NetworkBehaviourType.BugSwarm_Bee,
            AI_NetworkBehaviourType.Boar,
            AI_NetworkBehaviourType.StoneBird_Caravan,
            AI_NetworkBehaviourType.Llama,
            AI_NetworkBehaviourType.Pig
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_H = 
            {
            AI_NetworkBehaviourType.Boar,
            AI_NetworkBehaviourType.BugSwarm_Bee
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_I = 
            {
            AI_NetworkBehaviourType.Boar,
            AI_NetworkBehaviourType.Bear,
            AI_NetworkBehaviourType.Goat,
            AI_NetworkBehaviourType.Llama  
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_J = 
            {
            AI_NetworkBehaviourType.Pig
            };
        private static readonly AI_NetworkBehaviourType[] m_domesticTypes_K = 
            {
            AI_NetworkBehaviourType.Chicken,
            AI_NetworkBehaviourType.Goat,
            AI_NetworkBehaviourType.Llama
            };
        
        public static int rSpawnFactorAnimal = 1;
        public static int rSpawnFactorFish = 1;
        public static int rSpawnFactorSeagull = 1;
        public static int gMvI = 1;
        public static float rSpawnType = 1;
        public static string gmode = "Easy";
        public static int maxNumberOfSeagullAtOnce = 8;
        public static bool shouldSpawnThisPatch = true;
        public static int qtyBird = 0;

        [UsedImplicitly]
        public static bool Prefix(
                // ReSharper disable InconsistentNaming
                // ReSharper disable SuggestBaseTypeForParameter
                LandmarkEntitySpawner __instance)
        // ReSharper restore SuggestBaseTypeForParameter
        // ReSharper restore InconsistentNaming
        {
            //Debug.Log("visiting " + __instance.landmark.name);
            string spawningLandmark = __instance.landmark.name;

            if (!spawningLandmark.Contains("28#") && !spawningLandmark.Contains("29#") && !spawningLandmark.Contains("30#") && !spawningLandmark.Contains("31#") && !spawningLandmark.Contains("32#") && !spawningLandmark.Contains("33#"))
            {
                return true;
            }

            if (!Semih_Network.IsHost)
            {
                return true;
            }

            if (!m_domesticTypes.Contains(__instance.entityType))
            {
                return true;
            }

            if (m_isInPatchMode)
            {
                return true;
            }
            
            if (!shouldSpawnThisPatch) 
            {
                return true;
            }
            
            shouldSpawnThisPatch = false;
            
            gmode = GameModeValueManager.GetCurrentGameModeValue().gameMode.ToString();
		    if (gmode == "Hardcore") 
            { 
                gMvI = 2;
                maxNumberOfSeagullAtOnce = 20; 
            }
		    if (gmode == "Normal") 
            { 
                gMvI = 1;
                maxNumberOfSeagullAtOnce = 8; 
            }
            if (gmode == "Easy") 
            { 
                gMvI = 0;
                maxNumberOfSeagullAtOnce = 4;
            }

            qtyBird = ComponentManager<Network_Host_Entities>.Value.SeagullCount;
            rSpawnFactorFish = 0;
            rSpawnFactorSeagull = 0;
            rSpawnType = rand.Next(0,10);

            if (spawningLandmark.Contains("28#") || spawningLandmark.Contains("29#") || spawningLandmark.Contains("30#") || spawningLandmark.Contains("32#")) //Big islands randomisation
            {
                if (rSpawnType >= 9f)
                {
                    rSpawnFactorAnimal = rand.Next(1,4 + 2*gMvI);
                    if (rSpawnFactorAnimal == 1)
                    {
                        rSpawnType = 10f; //spawn the domestic island
                        rSpawnFactorAnimal = 10;
                    }
                }
                if (rSpawnType <= 8f)
                {
                    rSpawnFactorAnimal = rand.Next(1,5 + 2*gMvI);
                }
            }

            if (spawningLandmark.Contains("31#")) //Plane Island randomisation
            {
                rSpawnFactorAnimal = rand.Next(0,2);
            }

            if (spawningLandmark.Contains("33#")) //Boat Island randomisation
            {
                rSpawnFactorAnimal = rand.Next(0,3);
            }
            
            int doSpawnSeagull = rand.Next(1,8 - gMvI);
            if (doSpawnSeagull == 1) { rSpawnFactorSeagull = rand.Next(1,4*gMvI + 4); }
            if (rSpawnFactorSeagull + qtyBird > maxNumberOfSeagullAtOnce) { rSpawnFactorSeagull = maxNumberOfSeagullAtOnce - qtyBird; }

            int doSpawnPuffer = rand.Next(1,6 - gMvI);
            if (doSpawnPuffer <= 2) { rSpawnFactorFish = rand.Next(1,5*gMvI + 3); }

            try
            {
                m_isInPatchMode = true;
                
                var usableWaterLocations = __instance.landmark.GetComponentsInChildren<MonoBehaviour>()
                    .Where(p => m_usableWaterItemNames.Any(u => p.name.Contains(u)))
                    .ToArray();
                __instance.landmark.OnLandmarkRemoved += OnLandmarkRemoved;
                for (var i = 1; i <= rSpawnFactorFish; i++)
                {
                    var rangePosition = Random.Range(0, usableWaterLocations.Length);
                    var position = usableWaterLocations[rangePosition].transform.position;
                    var domesticType = AI_NetworkBehaviourType.PufferFish;
                    var behaviour = SpawnAnimal(domesticType, position);
                    m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                }

                var usableLocations = __instance.landmark.GetComponentsInChildren<MonoBehaviour>()
                    .Where(p => m_usableItemNames.Any(u => p.name.Contains(u)))
                    .ToArray();
                __instance.landmark.OnLandmarkRemoved += OnLandmarkRemoved;

                for (var i = 1; i <= rSpawnFactorSeagull; i++) 
                {
                    var rangePosition = Random.Range(0, usableLocations.Length);
                    var position = usableLocations[rangePosition].transform.position;
                    AddSeagull(position);
                }
                rSpawnFactorSeagull = 0;

                for (var i = 1; i <= rSpawnFactorAnimal; i++)
                {
                    var rangePosition = Random.Range(0, usableLocations.Length);
                    var position = usableLocations[rangePosition].transform.position;

                    if (rSpawnType == 0f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_A.Length);
                         var domesticType = m_domesticTypes_A[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 1f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_B.Length);
                         var domesticType = m_domesticTypes_B[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 2f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_C.Length);
                         var domesticType = m_domesticTypes_C[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 3f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_D.Length);
                         var domesticType = m_domesticTypes_D[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 4f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_E.Length);
                         var domesticType = m_domesticTypes_E[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 5f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_F.Length);
                         var domesticType = m_domesticTypes_F[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 6f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_G.Length);
                         var domesticType = m_domesticTypes_G[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 7f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_H.Length);
                         var domesticType = m_domesticTypes_H[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 8f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_I.Length);
                         var domesticType = m_domesticTypes_I[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 9f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_J.Length);
                         var domesticType = m_domesticTypes_J[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                    if (rSpawnType == 10f)
                    {
                         var rangeDomesticTypes = Random.Range(0, m_domesticTypes_K.Length);
                         var domesticType = m_domesticTypes_K[rangeDomesticTypes];
                         var behaviour = SpawnAnimal(domesticType, position);
                        m_disposableAnimals.Enqueue(behaviour.ObjectIndex);
                    }
                }
                
            }
            finally
            {
                m_isInPatchMode = false;
            }

            return true;
        }
        
        private static AI_NetworkBehaviour SpawnAnimal(AI_NetworkBehaviourType animalType, Vector3 position)
        {
            if (!Semih_Network.IsHost)
            {
                return null;
            }

            return ComponentManager<Network_Host_Entities>.Value.CreateAINetworkBehaviour(animalType, position);
        }

        private static void OnLandmarkRemoved()
        {
            while (m_disposableAnimals.Count > 0)
            {
                var index = m_disposableAnimals.Dequeue();
                NetworkIDManager.SendIDBehaviourDead(index, typeof(AI_NetworkBehaviour), true);
            }
        }
    }
}